# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

/* This is just a very simple lexical analizer for F90, keywords are reserved
and source form is completely free.
1) ';' also signals end of statement.
2) ^[*c] and ! comments are taken into account. (note that ^[*c] comment
   conflicts with "&\n" continuation.)
3) Deals with both free and fixed source form continuation lines. But
   the continuation cannot break a token...
*/

#include "extern.h"
#include "yacc.h"

#define YY_USER_ACTION zzleng=yyleng;zztext=yytext;

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) form_input(buf,&result,max_size,yyin)

char *zztext;
int zzlineno = 0, zzleng;
char *lex_last_name;

static int form_stmt_lines;  /* the # of lines of the last statement */
	/* 302 */
	/* 304 */
	/* 401 */
	/* 402 */
	/* 404 */
	/* 405 */
	/* 408 */
	/* 409 */
	/* 410 */
	/* 413 */
	/* 414 */
	/* 421 */
	/* ~ 311, 704, 724 */
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{
	Node *node = make (INTEGER_CONSTANT);

	kind_check ();
	node->com.str = U_str_copy (yytext);
	node->com.typ = typ_malloc ();
	node->com.typ->etype = Etype_INTEGER_0;
	yylval.node = node;
	return (INTEGER_CONSTANT);
}
break;
case 2:
{
	kind_check ();
	return (BINARY_CONSTANT);
}
break;
case 3:
{
	kind_check ();
	return (OCTAL_CONSTANT);
}
break;
case 4:
{
	kind_check ();
	return (HEX_CONSTANT);
}
break;
case 5:
{
	int c;
	char *str = U_str_copy (yytext);

	c = input();
	unput(c);

	if (isalpha(c)) {  /* catches .[a-z]+. */
		U_free (str);
		REJECT;
	}

	{
	Node *node = make (REAL_CONSTANT);

	kind_check ();

	node->com.str = str;
	node->com.typ = typ_malloc ();
	node->com.typ->etype = Etype_REAL_0;
	yylval.node = node;
	}

	return (REAL_CONSTANT);
}
break;
case 6:
{
	int c;
	char *str = U_str_copy (yytext);

	c = input();
	unput(c);

	if (isalpha(c)) {  /* catches .[a-z]+. */
		U_free (str);
		REJECT;
	}

	{
	Node *node = make (REAL_CONSTANT);

	kind_check ();

	node->com.str = str;
	node->com.typ = typ_malloc ();
	node->com.typ->etype = Etype_REAL_1;
	yylval.node = node;
	}

	return (REAL_CONSTANT);
}
break;
case 7:
{
	{
	Node *node = make (LOGICAL_CONSTANT);

	kind_check ();

	node->com.str = U_str_copy (yytext);
	node->com.typ = typ_malloc ();
	node->com.typ->etype = Etype_LOGICAL_0;
	yylval.node = node;
	}
	return (LOGICAL_CONSTANT);
}
break;
case 8:
		return (LPEQI);
break;
case 9:
		return (CHAR_SELECTOR_COMMA);
break;
case 10:
return (LDAC);
break;
case 11:
return (RDAC);
break;
case 12:
{
	stand ("'[' as array constructor delimiter");
	return (LDAC);
}
break;
case 13:
{
	stand ("']' as array constructor delimiter");
	return (RDAC);
}
break;
case 14:
	return ('=');
break;
case 15:
	return ('+');
break;
case 16:
	return ('-');
break;
case 17:
	return ('*');
break;
case 18:
	return ('/');
break;
case 19:
	return ('(');
break;
case 20:
	return (')');
break;
case 21:
	return (',');
break;
case 22:
	return ('.');
break;
case 23:
	return (':');
break;
case 24:
	return ('%');
break;
case 25:
	return ('?');
break;
case 26:
	return ('$');
break;
case 27:
	return (POWER_OP);
break;
case 28:
	return (CONCAT_OP);
break;
case 29:
	case 30:
	return (REL_OP_EQ);
break;
case 31:
	case 32:
	return (REL_OP_NE);
break;
case 33:
{
	stand ("relational operator '<>'");
	return (REL_OP_NE);
}
break;
case 34:
	case 35:
		return (REL_OP_LT);
break;
case 36:
	case 37:
	return (REL_OP_LE);
break;
case 38:
	case 39:
		return (REL_OP_GT);
break;
case 40:
	case 41:
	return (REL_OP_GE);
break;
case 42:
	return (POINT_OP);
break;
case 43:
	return (NOT_OP);
break;
case 44:
	return (AND_OP);
break;
case 45:
	return (OR_OP);
break;
case 46:
	return (XOR_OP);
break;
case 47:
	return (EQUIV_OP_T);
break;
case 48:
return (EQUIV_OP_F);
break;
case 49:
{
	process_string('.');
	return (DEFINED_UNARY_OP);
}
break;
case 50:
{
	Node *node = make (CHARACTER_CONSTANT);
	char *str = strings_list_fun (strings_current++);
	char *string_fix ();

	zztext = str;
	node->com.str = string_fix (str);

	node->com.typ = typ_malloc ();
	node->com.typ->etype = Etype_CHARACTER_0;

	yylval.node = node;

	return (CHARACTER_CONSTANT);
}
break;
case 51:
{
	int type = key_list_fun (key_current++);

	zztext = node_Symbol (type);

	if (type == FORMAT) {
		char c, *str;
		int i, num = -1, len;
		Node *node = make (FORMAT);

		strcpy (serr, "FORMAT (");

		while ((c = input ()) != '(' && c != '{')
			;
	
		for (i = 8;; i++) {
			c = input();
			serr[i] = c;

			if (c == '#') {
				c = input ();

				str = strings_list_fun (strings_current++);
				len = strlen (str);
				strcpy (serr + i, str);
				i = i + len - 1;
				continue;
			}

			switch (c) {

			case '\n':
				unput (c);
				fatal ("unmatched parenthesis in FORMAT");
			case ')':
				num++;
				if (num == 0) {
					serr[i+1] = '\0';
					node->com.str = U_str_copy (serr);
					yylval.node = node;
					return (FORMAT);
				}
				break;

			case '(':
				num--;
				break;
			}
		} 
	}

	return type;
}
break;
case 52:
{
	Node *node;

	if (flag_externals == 0)
		REJECT;

	node = make (NAME);

	node->com.str= U_str_copy (yytext);
	yylval.node = node;

	lex_last_name = node->com.str;

	return (NAME);
}
break;
case 53:
{
	Node *node;

	node = make (NAME);

	sprintf (serr, "name '%s' starts with an underscore", yytext);
	if (flag_standard)
		stand (serr);
	else
		warning (serr);

	node->com.str= U_str_copy (yytext);
	yylval.node = node;

	lex_last_name = node->com.str;

	return (NAME);
}
break;
case 54:
{
	Node *node = make (NAME);

	node->com.str= U_str_copy (yytext);
	yylval.node = node;

	lex_last_name = node->com.str;

	return (NAME);
}
break;
case 55:
{
/*!!! should add code that checks if there is a label afterwards ==> stand () */
	BEGIN 0;
	return (EOS);
}
break;
case 56:
{
	int c, ilen = 0;
	char len [10];

	BEGIN 0;

	while ((c = input ()) != '\n')
		len [ilen++] = c;
	len [ilen] = '\0';

	form_stmt_lines = atoi (len);
	zzlineno = zzlineno + form_stmt_lines;

	if (flag_verbose)
		ui_display (zzlineno);

	return (EOS);
}
break;
case 57:
;
break;
case 58:
{
	sprintf (serr, "'%c' ('\\%3o'): illegal character", yytext[0], yytext[0]);
	fatal (serr);
}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

static char *string_fix (str)
char *str;
{
	char *string, *temp0, *temp;

	temp0 = temp = (char*) U_malloc (2 * strlen (str));

	if (*str == '\"') {
		*temp++ = '\'';

		for (;;)
			switch (*++str) {
			case '\'':  /* ' --> '' */
				*temp++ = '\'';
				*temp++ = '\'';
				break;
			case '"':
				if (*(str+1) == '"') {  /* "" --> " */
					*temp++ = '"';
					str++;
				}
				else {
					*temp++ = '\'';
					goto eos;
				}
				break;
			default:
				*temp++ = *str;
			}

eos:
		*temp = '\0';
		string = U_str_copy (temp0);
		U_free (temp0);
	}
	else {
		string = U_str_copy (str);
	}

	return string;
}

static process_strin